<template>
  <div>
    <br />
    <b-alert show variant="dark text-center">
      <strong> LES FILTRES </strong>
    </b-alert>
    <div>
      <b-container fluid>
        <b-row>
          <b-col><BrandFilter /></b-col>
          <b-col> <ModelFilter /> </b-col>
          <b-col> <MotorizationFilter /> </b-col>
        </b-row>
        <br />
        <b-row>
          <b-col> <BodyWorkFilter /> </b-col>
          <b-col> <NumberOfPlacesFilter /> </b-col>
          <b-col> <Co2Filter /> </b-col>
        </b-row>
        <br />

        <b-row>
          <b-col> <PriceFilter /> </b-col>

          <b-col>
            <b-container fluid>
              <b-row class="my-1">
                <b-col sm="6">
                  <label> N° de resultats par page </label>
                </b-col>
                <b-col sm="5">
                  <b-form-input
                    v-model="perPage"
                    min="1"
                    :id="`type-${type}`"
                    :type="type"
                  ></b-form-input>
                </b-col>
              </b-row>
            </b-container>
          </b-col>
          <b-col> </b-col>
        </b-row>
      </b-container>
    </div>

    <div class="col text-center">
      <b-button
        @click="updateTable"
        pill
        :variant="colorButton"
        class="btn btn-default"
        >Mettre à jour les resultats</b-button
      >
      &ensp;
      <b-button
        pill
        variant="outline-danger"
        class="btn btn-default"
        @click="clearFilters"
      >
        Effacer les filtres
      </b-button>
    </div>
  </div>
</template>

<script>
import BrandFilter from "./BrandFilter";
import ModelFilter from "./ModelFilter";
import MotorizationFilter from "./MotorizationFilter";
import PriceFilter from "./PriceFilter";
import Co2Filter from "./Co2Filter";
import BodyWorkFilter from "./BodyWorkFilter";
import NumberOfPlacesFilter from "./NumberOfPlacesFilter";

export default {
  data() {
    return {
      perPage: this.$store.getters.perPage,
      type: "number",
    };
  },
  components: {
    BrandFilter,
    ModelFilter,
    MotorizationFilter,
    PriceFilter,
    Co2Filter,
    BodyWorkFilter,
    NumberOfPlacesFilter,
  },

  computed: {
    colorButton() {
      return this.$store.getters.colorButton;
    },
  },
  methods: {
    updateTable() {
      this.$store.dispatch("updateTable");
      this.$store.dispatch("updateColorButton", "outline-success");
    },
    clearFilters() {
      this.$store.dispatch("fetchResults");
      this.$store.dispatch("updateColorButton", "outline-success");
    },
  },
  watch: {
    perPage(newVal) {
      this.$store.dispatch("updatePerPage", newVal);
    },
  },
};
</script>

